.586
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include comctl32.inc
includelib comctl32.lib

;***************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

getPath proto hTreeView:HANDLE,hItem:HANDLE,pBuff:DWORD,bufflen:DWORD
hasChildren proto pPath:DWORD
addChildren proto hTreeView:HANDLE,hParentItem:HANDLE
initTree proto hTreeView:HANDLE

TreeAddItem proto hTreeView:HANDLE,pText:DWORD,uid:DWORD,kids:DWORD,hParentItem:HANDLE

;***************************************************************************************************

IDDIRTREE       equ 10001

WIN_WIDTH       equ 300
WIN_HEIGHT      equ 400

;***************************************************************************************************

.const
AppName         db "DirTree",0
TvClass         db "SysTreeView32",0
strAllFiles     db "\*.*",0

.data?
hInstance   HINSTANCE   ?
hWnd        HWND        ?
hTv         HANDLE      ?

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;***************************************************************************************************

ALIGN 4
WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    mov [wc].cbSize,SIZEOF wc
    mov [wc].style,NULL
    mov [wc].lpfnWndProc,OFFSET WndProc
    mov eax,hInstance
    mov [wc].hInstance,eax
    invoke LoadIcon, NULL,IDI_APPLICATION
    mov [wc].hIcon,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov [wc].hCursor,eax
    mov [wc].hbrBackground,COLOR_BTNFACE+1
    mov [wc].lpszClassName,OFFSET AppName
    xor eax,eax
    mov [wc].cbClsExtra,eax
    mov [wc].cbWndExtra,eax
    mov [wc].lpszMenuName,eax
    mov [wc].hIconSm,eax
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx, NULL,ADDR AppName,ADDR AppName,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,WIN_WIDTH,WIN_HEIGHT,NULL,NULL,hInstance,NULL
    .IF (eax)
        push ebx
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        lea ebx,[msg]
        assume ebx:ptr MSG
        .WHILE TRUE
            xor eax,eax
            invoke GetMessage, ebx,eax,eax,eax
            .BREAK .IF(!eax)
            invoke TranslateMessage, ebx
            invoke DispatchMessage, ebx
        .ENDW
        mov eax,[ebx].wParam
        assume ebx:nothing
        pop ebx
    .ENDIF
    ret
WinMain endp

ALIGN 4
WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg
;-- WM_NOTIFY --------------------------------------------------------------------------------------
    .IF (eax==WM_NOTIFY)
        mov ecx,lParam
        assume ecx:ptr NMHDR
        mov eax,[ecx].hwndFrom
        mov edx,[ecx].code
        .IF (eax==hTv)
            .IF (edx==TVN_ITEMEXPANDING)
                assume ecx:ptr NM_TREEVIEW
                mov eax,[ecx].action
                .IF (eax==TVE_EXPAND)
                    ;;[ecx].itemNew = TV_ITEM struct
                    ;;(hItem = parent item, state and lParam are valid)
                    mov eax,[ecx].itemNew.state
                    test eax,TVIS_EXPANDEDONCE
                    .IF (ZERO?)
                        mov eax,[ecx].itemNew.hItem
                        invoke addChildren, hTv,eax
                    .ENDIF
                .ENDIF
            .ENDIF
        .ENDIF
        assume ecx:nothing
;-- WM_SIZE ----------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_SIZE)
        mov eax,lParam
        mov edx,eax
        and eax,0ffffh  ;width
        shr edx,16      ;height
        invoke MoveWindow, hTv,0,0,eax,edx,TRUE
;-- WM_SETFOCUS ------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_SETFOCUS)
        invoke SetFocus, hTv
;-- WM_CREATE --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        invoke InitCommonControls
        invoke CreateWindowEx, WS_EX_STATICEDGE,ADDR TvClass,NULL,WS_CHILD or WS_CLIPSIBLINGS or WS_VISIBLE or TVS_LINESATROOT or TVS_HASBUTTONS or TVS_DISABLEDRAGDROP,0,0,0,0,hwnd,IDDIRTREE,hInstance,NULL
        mov hTv,eax
        invoke initTree, hTv
;-- WM_DESTROY -------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke PostQuitMessage, NULL
;-- default ----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

;***************************************************************************************************

ALIGN 4
getPath proc hTreeView:HANDLE,hItem:HANDLE,pBuff:DWORD,bufflen:DWORD
    LOCAL tvitem:TV_ITEM
    push esi
    push edi
    push ebx
    mov edi,pBuff
    lea esi,[tvitem]
    assume esi:ptr TV_ITEM
    mov ebx,hItem
    push 0  ;sentinel
  @@:
    push ebx
    invoke SendMessage, hTreeView,TVM_GETNEXTITEM,TVGN_PARENT,ebx
    test eax,eax
    mov ebx,eax
    jnz @B
  @@:
    pop ebx
    test ebx,ebx
    jz @F
    mov [esi].imask,TVIF_HANDLE or TVIF_TEXT
    mov [esi].hItem,ebx
    mov [esi].pszText,edi
    mov [esi].cchTextMax,260    ;hack (but safe for our purposes)
    invoke SendMessage, hTreeView,TVM_GETITEM,0,esi
    invoke lstrlen, edi
    add edi,eax
    mov BYTE PTR [edi],'\'
    inc edi
    jmp @B
  @@:
    mov BYTE PTR [edi],bl   ;00h
    mov eax,edi
    sub eax,pBuff
    assume esi:nothing
    pop ebx
    pop edi
    pop esi
    ;return length of the path written to pBuff
    ret
getPath endp

ALIGN 4
hasChildren proc pPath:DWORD
    LOCAL fnddata:WIN32_FIND_DATA
    LOCAL basepath[320]:BYTE
    push esi
    push ebx
    lea eax,[basepath]
    lea esi,[fnddata]
    assume esi:ptr WIN32_FIND_DATA
    invoke lstrcpy, eax,pPath
    invoke lstrcat, eax,ADDR strAllFiles
    invoke FindFirstFile, eax,esi
    .IF (eax!=INVALID_HANDLE_VALUE)
        mov ebx,eax
      @@:
        lea edx,[esi].cFileName
        mov eax,[esi].dwFileAttributes
        mov ecx,[edx]
        and ecx,0FFFFh
        .IF ((ecx != 002eh) && (ecx != 2e2eh))  ;ignore "." and ".."
            mov eax,TRUE
            jmp @fin
        .ENDIF
        invoke FindNextFile, ebx,esi
        test eax,eax
        jnz @B
      @fin:
        push eax
        invoke FindClose, ebx
        pop eax
    .ELSE
        xor eax,eax ;FALSE
    .ENDIF
    assume esi:nothing
    pop ebx
    pop esi
    ret
hasChildren endp

ALIGN 4
addChildren proc hTreeView:HANDLE,hParentItem:HANDLE
    LOCAL fnddata:WIN32_FIND_DATA
    LOCAL basepath[320]:BYTE
    LOCAL pathpos:DWORD
    push edi
    push esi
    push ebx
    lea edi,[basepath]
    lea esi,[fnddata]
    assume esi:ptr WIN32_FIND_DATA
    invoke getPath, hTreeView,hParentItem,edi,SIZEOF basepath
    add eax,edi
    mov pathpos,eax
    mov DWORD PTR [eax],'*.*'
    invoke FindFirstFile, edi,esi
    .IF (eax!=INVALID_HANDLE_VALUE)
        mov ebx,eax
      @@:
        lea edx,[esi].cFileName
        mov eax,[esi].dwFileAttributes
        mov ecx,[edx]
        and ecx,0FFFFh
        .IF ((ecx != 002eh) && (ecx != 2e2eh))  ;skip "." and ".."
            push hParentItem    ;hParentItem
            push 0              ;kids
            push ecx            ;uid
            push edx            ;pText
            push hTreeView      ;hTreeView
            test eax,FILE_ATTRIBUTE_DIRECTORY
            .IF (!ZERO?)
                invoke lstrcpy, pathpos,edx
                invoke hasChildren, edi
                mov [esp+(4*3)],eax     ;correct the 'kids' parameter
            .ENDIF
            call TreeAddItem
        .ENDIF
        invoke FindNextFile, ebx,esi
        test eax,eax
        jnz @B
        invoke FindClose, ebx
        mov eax,TRUE
    .ELSE
        xor eax,eax ;FALSE
    .ENDIF
    assume esi:nothing
    pop ebx
    pop esi
    pop edi
    ret
addChildren endp

ALIGN 4
initTree proc hTreeView:HANDLE
    LOCAL drvstr:DWORD
    push esi
    push ebx
    invoke SendMessage, hTreeView,WM_SETREDRAW,FALSE,NULL
    lea esi,[drvstr]
    invoke GetLogicalDrives
    mov edx,':A'
    mov ebx,eax
  @@:
    shr ebx,1
    .IF (CARRY?)
        xor eax,eax
        mov [esi],edx
        invoke hasChildren, esi
        invoke TreeAddItem, hTreeView,esi,NULL,eax,TVI_ROOT
        mov edx,[esi]
    .ENDIF
    add edx,1
    test ebx,ebx
    jnz @B
    invoke SendMessage, hTreeView,WM_SETREDRAW,TRUE,NULL
    pop ebx
    pop esi
    ret
initTree endp

;***************************************************************************************************

ALIGN 4
TreeAddItem proc hTreeView:HANDLE,pText:DWORD,uid:DWORD,kids:DWORD,hParentItem:HANDLE
    LOCAL is:TV_INSERTSTRUCT
    push esi
    lea esi,[is]
    assume esi:PTR TV_INSERTSTRUCT
    mov eax,hParentItem
    mov [esi].hParent,eax
    mov [esi].hInsertAfter,TVI_LAST
    mov [esi].item.imask,TVIF_TEXT or TVIF_PARAM or TVIF_CHILDREN
    mov eax,pText
    mov edx,uid
    mov ecx,kids
    mov [esi].item.pszText,eax
    mov [esi].item.lParam,edx
    mov [esi].item.cChildren,ecx
    invoke SendMessage, hTreeView,TVM_INSERTITEM,NULL,esi
    pop esi
    assume esi:nothing
    ;return value is the handle of the item added, or null if failure
    ret
TreeAddItem endp

;***************************************************************************************************

end start
